/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// AWSMachineTemplateLister helps list AWSMachineTemplates.
// All objects returned here must be treated as read-only.
type AWSMachineTemplateLister interface {
	// List lists all AWSMachineTemplates in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSMachineTemplate, err error)
	// AWSMachineTemplates returns an object that can list and get AWSMachineTemplates.
	AWSMachineTemplates(namespace string) AWSMachineTemplateNamespaceLister
	AWSMachineTemplateListerExpansion
}

// aWSMachineTemplateLister implements the AWSMachineTemplateLister interface.
type aWSMachineTemplateLister struct {
	indexer cache.Indexer
}

// NewAWSMachineTemplateLister returns a new AWSMachineTemplateLister.
func NewAWSMachineTemplateLister(indexer cache.Indexer) AWSMachineTemplateLister {
	return &aWSMachineTemplateLister{indexer: indexer}
}

// List lists all AWSMachineTemplates in the indexer.
func (s *aWSMachineTemplateLister) List(selector labels.Selector) (ret []*v1beta2.AWSMachineTemplate, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSMachineTemplate))
	})
	return ret, err
}

// AWSMachineTemplates returns an object that can list and get AWSMachineTemplates.
func (s *aWSMachineTemplateLister) AWSMachineTemplates(namespace string) AWSMachineTemplateNamespaceLister {
	return aWSMachineTemplateNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// AWSMachineTemplateNamespaceLister helps list and get AWSMachineTemplates.
// All objects returned here must be treated as read-only.
type AWSMachineTemplateNamespaceLister interface {
	// List lists all AWSMachineTemplates in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSMachineTemplate, err error)
	// Get retrieves the AWSMachineTemplate from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta2.AWSMachineTemplate, error)
	AWSMachineTemplateNamespaceListerExpansion
}

// aWSMachineTemplateNamespaceLister implements the AWSMachineTemplateNamespaceLister
// interface.
type aWSMachineTemplateNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all AWSMachineTemplates in the indexer for a given namespace.
func (s aWSMachineTemplateNamespaceLister) List(selector labels.Selector) (ret []*v1beta2.AWSMachineTemplate, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSMachineTemplate))
	})
	return ret, err
}

// Get retrieves the AWSMachineTemplate from the indexer for a given namespace and name.
func (s aWSMachineTemplateNamespaceLister) Get(name string) (*v1beta2.AWSMachineTemplate, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta2.Resource("awsmachinetemplate"), name)
	}
	return obj.(*v1beta2.AWSMachineTemplate), nil
}
